/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/geometric_shapes_msgs/msg/Shape.msg.  Do not edit! */
#ifndef GEOMETRIC_SHAPES_MSGS_SHAPE_H
#define GEOMETRIC_SHAPES_MSGS_SHAPE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"

namespace geometric_shapes_msgs
{

//! \htmlinclude Shape.msg.html

class Shape : public ros::Message
{
public:
  typedef boost::shared_ptr<Shape> Ptr;
  typedef boost::shared_ptr<Shape const> ConstPtr;

  typedef int8_t _type_type;
  typedef std::vector<double> _dimensions_type;
  typedef std::vector<int32_t> _triangles_type;
  typedef std::vector<geometry_msgs::Point> _vertices_type;

  const static int8_t SPHERE = 0;
  const static int8_t BOX = 1;
  const static int8_t CYLINDER = 2;
  const static int8_t MESH = 3;
  int8_t type;
  std::vector<double> dimensions;
  std::vector<int32_t> triangles;
  std::vector<geometry_msgs::Point> vertices;

  Shape() : ros::Message(),
    type(0)
  {
  }
  Shape(const Shape &copy) : ros::Message(),
    type(copy.type)
  {
    (void)copy;
    dimensions = copy.dimensions;
    triangles = copy.triangles;
    vertices = copy.vertices;
  }
  Shape &operator =(const Shape &copy)
  {
    if (this == &copy)
      return *this;
    dimensions.clear();
    triangles.clear();
    vertices.clear();
    type = copy.type;
    dimensions = copy.dimensions;
    triangles = copy.triangles;
    vertices = copy.vertices;
    return *this;
  }
  virtual ~Shape() 
  {
    dimensions.clear();
    triangles.clear();
    vertices.clear();
  }
  inline static std::string __s_getDataType() { return std::string("geometric_shapes_msgs/Shape"); }
  inline static std::string __s_getMD5Sum() { return std::string("59935940044147de75e7523b5d37c4d7"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_dimensions_size(uint32_t __ros_new_size)
  {
    this->dimensions.resize(__ros_new_size);
  }
  inline uint32_t get_dimensions_size() const { return dimensions.size(); }
  inline void get_dimensions_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->dimensions;
  }
  inline void set_dimensions_vec(const std::vector<double> &__ros_vec)
  {
    this->dimensions = __ros_vec;
  }
  void set_triangles_size(uint32_t __ros_new_size)
  {
    this->triangles.resize(__ros_new_size);
  }
  inline uint32_t get_triangles_size() const { return triangles.size(); }
  inline void get_triangles_vec (std::vector<int32_t> &__ros_vec) const
  {
    __ros_vec = this->triangles;
  }
  inline void set_triangles_vec(const std::vector<int32_t> &__ros_vec)
  {
    this->triangles = __ros_vec;
  }
  void set_vertices_size(uint32_t __ros_new_size)
  {
    this->vertices.resize(__ros_new_size);
  }
  inline uint32_t get_vertices_size() const { return vertices.size(); }
  inline void get_vertices_vec (std::vector<geometry_msgs::Point> &__ros_vec) const
  {
    __ros_vec = this->vertices;
  }
  inline void set_vertices_vec(const std::vector<geometry_msgs::Point> &__ros_vec)
  {
    this->vertices = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 0; // SPHERE
    __l += 0; // BOX
    __l += 0; // CYLINDER
    __l += 0; // MESH
    __l += 1; // type
    __l += 4 + (dimensions.size() ? dimensions.size() * 8 : 0); // dimensions
    __l += 4 + (triangles.size() ? triangles.size() * 4 : 0); // triangles
    __l += 4 + (vertices.size() ? vertices.size() * vertices[0].serializationLength() : 0); // vertices
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, type);
    uint32_t __dimensions_size = dimensions.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __dimensions_size);
    memcpy(write_ptr, &dimensions[0], sizeof(double) * __dimensions_size);
    write_ptr += sizeof(double) * __dimensions_size;
    uint32_t __triangles_size = triangles.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __triangles_size);
    memcpy(write_ptr, &triangles[0], sizeof(int32_t) * __triangles_size);
    write_ptr += sizeof(int32_t) * __triangles_size;
    uint32_t __vertices_size = vertices.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __vertices_size);
    for (size_t i = 0; i < __vertices_size; i++)
      write_ptr = vertices[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, type);
    uint32_t __dimensions_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __dimensions_size);
    set_dimensions_size(__dimensions_size);
    memcpy(&dimensions[0], read_ptr, sizeof(double) * __dimensions_size);
    read_ptr += sizeof(double) * __dimensions_size;
    uint32_t __triangles_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __triangles_size);
    set_triangles_size(__triangles_size);
    memcpy(&triangles[0], read_ptr, sizeof(int32_t) * __triangles_size);
    read_ptr += sizeof(int32_t) * __triangles_size;
    uint32_t __vertices_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __vertices_size);
    set_vertices_size(__vertices_size);
    for (size_t i = 0; i < __vertices_size; i++)
      read_ptr = vertices[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Shape> ShapePtr;
typedef boost::shared_ptr<Shape const> ShapeConstPtr;


}

#endif
