/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/mapping_msgs/msg/PolygonalMap.msg.  Do not edit! */
#ifndef MAPPING_MSGS_POLYGONALMAP_H
#define MAPPING_MSGS_POLYGONALMAP_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point32.h"
#include "geometry_msgs/Polygon.h"
#include "sensor_msgs/ChannelFloat32.h"

namespace mapping_msgs
{

//! \htmlinclude PolygonalMap.msg.html

class PolygonalMap : public ros::Message
{
public:
  typedef boost::shared_ptr<PolygonalMap> Ptr;
  typedef boost::shared_ptr<PolygonalMap const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<geometry_msgs::Polygon> _polygons_type;
  typedef std::vector<sensor_msgs::ChannelFloat32> _chan_type;

  roslib::Header header;
  std::vector<geometry_msgs::Polygon> polygons;
  std::vector<sensor_msgs::ChannelFloat32> chan;

  PolygonalMap() : ros::Message()
  {
  }
  PolygonalMap(const PolygonalMap &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    polygons = copy.polygons;
    chan = copy.chan;
  }
  PolygonalMap &operator =(const PolygonalMap &copy)
  {
    if (this == &copy)
      return *this;
    polygons.clear();
    chan.clear();
    header = copy.header;
    polygons = copy.polygons;
    chan = copy.chan;
    return *this;
  }
  virtual ~PolygonalMap() 
  {
    polygons.clear();
    chan.clear();
  }
  inline static std::string __s_getDataType() { return std::string("mapping_msgs/PolygonalMap"); }
  inline static std::string __s_getMD5Sum() { return std::string("3ef041ea9abaaa9dac3e5aec60c68a99"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "Header header\n"
    "geometry_msgs/Polygon[] polygons\n"
    "sensor_msgs/ChannelFloat32[] chan\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Polygon\n"
    "#A specification of a polygon where the first and last points are assumed to be connected\n"
    "geometry_msgs/Point32[] points\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "================================================================================\n"
    "MSG: sensor_msgs/ChannelFloat32\n"
    "#This message is used by the PointCloud message to hold optional data associated with each point in the cloud\n"
    "#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point\n"
    "\n"
    "string name       #channel name should give semantics of the channel (e.g. \"intensity\" instead of \"value\")\n"
    "float32[] values  #values array should have same number of elements as the associated PointCloud\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_polygons_size(uint32_t __ros_new_size)
  {
    this->polygons.resize(__ros_new_size);
  }
  inline uint32_t get_polygons_size() const { return polygons.size(); }
  uint32_t calc_polygons_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t polygons_size = polygons.size();
    for (size_t i = 0; i < polygons_size; i++)
      l += polygons[i].serializationLength();
    return l;
  }
  inline void get_polygons_vec (std::vector<geometry_msgs::Polygon> &__ros_vec) const
  {
    __ros_vec = this->polygons;
  }
  inline void set_polygons_vec(const std::vector<geometry_msgs::Polygon> &__ros_vec)
  {
    this->polygons = __ros_vec;
  }
  void set_chan_size(uint32_t __ros_new_size)
  {
    this->chan.resize(__ros_new_size);
  }
  inline uint32_t get_chan_size() const { return chan.size(); }
  uint32_t calc_chan_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t chan_size = chan.size();
    for (size_t i = 0; i < chan_size; i++)
      l += chan[i].serializationLength();
    return l;
  }
  inline void get_chan_vec (std::vector<sensor_msgs::ChannelFloat32> &__ros_vec) const
  {
    __ros_vec = this->chan;
  }
  inline void set_chan_vec(const std::vector<sensor_msgs::ChannelFloat32> &__ros_vec)
  {
    this->chan = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_polygons_array_serialization_len(); // polygons
    __l += 4 + calc_chan_array_serialization_len(); // chan
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __polygons_size = polygons.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __polygons_size);
    for (size_t i = 0; i < __polygons_size; i++)
      write_ptr = polygons[i].serialize(write_ptr, seq);
    uint32_t __chan_size = chan.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __chan_size);
    for (size_t i = 0; i < __chan_size; i++)
      write_ptr = chan[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __polygons_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __polygons_size);
    set_polygons_size(__polygons_size);
    for (size_t i = 0; i < __polygons_size; i++)
      read_ptr = polygons[i].deserialize(read_ptr);
    uint32_t __chan_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __chan_size);
    set_chan_size(__chan_size);
    for (size_t i = 0; i < __chan_size; i++)
      read_ptr = chan[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PolygonalMap> PolygonalMapPtr;
typedef boost::shared_ptr<PolygonalMap const> PolygonalMapConstPtr;


}

#endif
