# autogenerated by genmsg_py from CollisionMap.msg. Do not edit.
import roslib.message
import struct

import mapping_msgs.msg
import geometry_msgs.msg
import roslib.msg

class CollisionMap(roslib.message.Message):
  _md5sum = "18ca54db41ccebbe82f61f9801dede89"
  _type = "mapping_msgs/CollisionMap"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """#header for interpreting box positions
Header header

#boxes for use in collision testing
OrientedBoundingBox[] boxes

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: mapping_msgs/OrientedBoundingBox
#the center of the box
geometry_msgs/Point32 center

#the extents of the box, assuming the center is at the point
geometry_msgs/Point32 extents

#the axis of the box
geometry_msgs/Point32 axis

#the angle of rotation around the axis
float32 angle

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
"""
  __slots__ = ['header','boxes']
  _slot_types = ['Header','mapping_msgs/OrientedBoundingBox[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,boxes
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(CollisionMap, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.boxes is None:
        self.boxes = []
    else:
      self.header = roslib.msg._Header.Header()
      self.boxes = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.boxes
      length = len(self.boxes)
      buff.write(struct.pack('<I', length))
      for val1 in self.boxes:
        buff.write(struct.pack('<3f', val1.center.x, val1.center.y, val1.center.z))
        buff.write(struct.pack('<3f', val1.extents.x, val1.extents.y, val1.extents.z))
        buff.write(struct.pack('<3f', val1.axis.x, val1.axis.y, val1.axis.z))
        buff.write(struct.pack('<f', val1.angle))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.boxes
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.boxes = []
      for i in xrange(0, length):
        val1 = mapping_msgs.msg.OrientedBoundingBox()
        start = end
        end += 12
        (val1.center.x, val1.center.y, val1.center.z,) = struct.unpack('<3f',str[start:end])
        start = end
        end += 12
        (val1.extents.x, val1.extents.y, val1.extents.z,) = struct.unpack('<3f',str[start:end])
        start = end
        end += 12
        (val1.axis.x, val1.axis.y, val1.axis.z,) = struct.unpack('<3f',str[start:end])
        start = end
        end += 4
        (val1.angle,) = struct.unpack('<f',str[start:end])
        self.boxes.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.boxes
      length = len(self.boxes)
      buff.write(struct.pack('<I', length))
      for val1 in self.boxes:
        buff.write(struct.pack('<3f', val1.center.x, val1.center.y, val1.center.z))
        buff.write(struct.pack('<3f', val1.extents.x, val1.extents.y, val1.extents.z))
        buff.write(struct.pack('<3f', val1.axis.x, val1.axis.y, val1.axis.z))
        buff.write(struct.pack('<f', val1.angle))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.boxes
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.boxes = []
      for i in xrange(0, length):
        val1 = mapping_msgs.msg.OrientedBoundingBox()
        start = end
        end += 12
        (val1.center.x, val1.center.y, val1.center.z,) = struct.unpack('<3f',str[start:end])
        start = end
        end += 12
        (val1.extents.x, val1.extents.y, val1.extents.z,) = struct.unpack('<3f',str[start:end])
        start = end
        end += 12
        (val1.axis.x, val1.axis.y, val1.axis.z,) = struct.unpack('<3f',str[start:end])
        start = end
        end += 4
        (val1.angle,) = struct.unpack('<f',str[start:end])
        self.boxes.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

