/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/AllowedContactSpecification.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_ALLOWEDCONTACTSPECIFICATION_H
#define MOTION_PLANNING_MSGS_ALLOWEDCONTACTSPECIFICATION_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "roslib/Header.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"

namespace motion_planning_msgs
{

//! \htmlinclude AllowedContactSpecification.msg.html

class AllowedContactSpecification : public ros::Message
{
public:
  typedef boost::shared_ptr<AllowedContactSpecification> Ptr;
  typedef boost::shared_ptr<AllowedContactSpecification const> ConstPtr;

  typedef std::string _name_type;
  typedef geometric_shapes_msgs::Shape _shape_type;
  typedef geometry_msgs::PoseStamped _pose_stamped_type;
  typedef std::vector<std::string> _link_names_type;
  typedef double _penetration_depth_type;

  std::string name;
  geometric_shapes_msgs::Shape shape;
  geometry_msgs::PoseStamped pose_stamped;
  std::vector<std::string> link_names;
  double penetration_depth;

  AllowedContactSpecification() : ros::Message(),
    penetration_depth(0)
  {
  }
  AllowedContactSpecification(const AllowedContactSpecification &copy) : ros::Message(),
    name(copy.name),
    shape(copy.shape),
    pose_stamped(copy.pose_stamped),
    penetration_depth(copy.penetration_depth)
  {
    (void)copy;
    link_names = copy.link_names;
  }
  AllowedContactSpecification &operator =(const AllowedContactSpecification &copy)
  {
    if (this == &copy)
      return *this;
    link_names.clear();
    name = copy.name;
    shape = copy.shape;
    pose_stamped = copy.pose_stamped;
    link_names = copy.link_names;
    penetration_depth = copy.penetration_depth;
    return *this;
  }
  virtual ~AllowedContactSpecification() 
  {
    link_names.clear();
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/AllowedContactSpecification"); }
  inline static std::string __s_getMD5Sum() { return std::string("81f9b47ac49a467ae008d3d9485628a3"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# The names of the regions\n"
    "string name\n"
    "\n"
    "# The shape of the region in the environment\n"
    "geometric_shapes_msgs/Shape shape\n"
    "\n"
    "# The pose of the space defining the region\n"
    "geometry_msgs/PoseStamped pose_stamped\n"
    "\n"
    "# The set of links that will be allowed to have penetration contact within this region\n"
    "string[] link_names\n"
    "\n"
    "# The maximum penetration depth allowed for every link\n"
    "float64 penetration_depth\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_link_names_size(uint32_t __ros_new_size)
  {
    this->link_names.resize(__ros_new_size);
  }
  inline uint32_t get_link_names_size() const { return link_names.size(); }
  uint32_t calc_link_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t link_names_size = link_names.size();
    for (size_t i = 0; i < link_names_size; i++)
      l += 4 + link_names[i].length();
    return l;
  }
  inline void get_link_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->link_names;
  }
  inline void set_link_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->link_names = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + name.length(); // name
    __l += shape.serializationLength(); // shape
    __l += pose_stamped.serializationLength(); // pose_stamped
    __l += 4 + calc_link_names_array_serialization_len(); // link_names
    __l += 8; // penetration_depth
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_name_len = name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, name.c_str(), __ros_name_len);
    write_ptr = shape.serialize(write_ptr, seq);
    write_ptr = pose_stamped.serialize(write_ptr, seq);
    uint32_t __link_names_size = link_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len = link_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_link_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, link_names[i].c_str(), __ros_link_names_i__len);
    }
    SROS_SERIALIZE_PRIMITIVE(write_ptr, penetration_depth);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_len);
    name = std::string((const char *)read_ptr, __ros_name_len);
    read_ptr += __ros_name_len;
    read_ptr = shape.deserialize(read_ptr);
    read_ptr = pose_stamped.deserialize(read_ptr);
    uint32_t __link_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __link_names_size);
    set_link_names_size(__link_names_size);
    for (size_t i = 0; i < __link_names_size; i++)
    {
      unsigned __ros_link_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_link_names_i__len);
    link_names[i] = std::string((const char *)read_ptr, __ros_link_names_i__len);
    read_ptr += __ros_link_names_i__len;
    }
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, penetration_depth);
    return read_ptr;
  }
};

typedef boost::shared_ptr<AllowedContactSpecification> AllowedContactSpecificationPtr;
typedef boost::shared_ptr<AllowedContactSpecification const> AllowedContactSpecificationConstPtr;


}

#endif
