/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/CollisionOperation.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_COLLISIONOPERATION_H
#define MOTION_PLANNING_MSGS_COLLISIONOPERATION_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace motion_planning_msgs
{

//! \htmlinclude CollisionOperation.msg.html

class CollisionOperation : public ros::Message
{
public:
  typedef boost::shared_ptr<CollisionOperation> Ptr;
  typedef boost::shared_ptr<CollisionOperation const> ConstPtr;

  typedef std::string _object1_type;
  typedef std::string _object2_type;
  typedef double _penetration_distance_type;
  typedef int32_t _operation_type;

  std::string object1;
  std::string object2;
  const std::string COLLISION_SET_ALL;
  const std::string COLLISION_SET_OBJECTS;
  const std::string COLLISION_SET_ATTACHED_OBJECTS;
  double penetration_distance;
  int32_t operation;
  const static int32_t DISABLE = 0;
  const static int32_t ENABLE = 1;

  CollisionOperation() : ros::Message(),
    COLLISION_SET_ALL("\"all\""),
    COLLISION_SET_OBJECTS("\"objects\""),
    COLLISION_SET_ATTACHED_OBJECTS("\"attached\""),
    penetration_distance(0),
    operation(0)
  {
  }
  CollisionOperation(const CollisionOperation &copy) : ros::Message(),
    object1(copy.object1),
    object2(copy.object2),
    COLLISION_SET_ALL(copy.COLLISION_SET_ALL),
    COLLISION_SET_OBJECTS(copy.COLLISION_SET_OBJECTS),
    COLLISION_SET_ATTACHED_OBJECTS(copy.COLLISION_SET_ATTACHED_OBJECTS),
    penetration_distance(copy.penetration_distance),
    operation(copy.operation)
  {
    (void)copy;
  }
  CollisionOperation &operator =(const CollisionOperation &copy)
  {
    if (this == &copy)
      return *this;
    object1 = copy.object1;
    object2 = copy.object2;
    penetration_distance = copy.penetration_distance;
    operation = copy.operation;
    return *this;
  }
  virtual ~CollisionOperation() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/CollisionOperation"); }
  inline static std::string __s_getMD5Sum() { return std::string("e0cf3073b26bd86266c918a0c779f8a2"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A definition of a collision operation\n"
    "# E.g. (\"gripper\",COLLISION_SET_ALL,ENABLE) will enable collisions \n"
    "# between the gripper and all objects in the collision space\n"
    "\n"
    "string object1\n"
    "string object2\n"
    "string COLLISION_SET_ALL=\"all\"\n"
    "string COLLISION_SET_OBJECTS=\"objects\"\n"
    "string COLLISION_SET_ATTACHED_OBJECTS=\"attached\"\n"
    "\n"
    "# The penetration distance to which collisions are allowed. This is 0.0 by default.\n"
    "float64 penetration_distance\n"
    "\n"
    "# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above\n"
    "int32 operation\n"
    "int32 DISABLE=0\n"
    "int32 ENABLE=1\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + object1.length(); // object1
    __l += 4 + object2.length(); // object2
    __l += 0; // COLLISION_SET_ALL
    __l += 0; // COLLISION_SET_OBJECTS
    __l += 0; // COLLISION_SET_ATTACHED_OBJECTS
    __l += 8; // penetration_distance
    __l += 4; // operation
    __l += 0; // DISABLE
    __l += 0; // ENABLE
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_object1_len = object1.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_object1_len);
    SROS_SERIALIZE_BUFFER(write_ptr, object1.c_str(), __ros_object1_len);
    unsigned __ros_object2_len = object2.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_object2_len);
    SROS_SERIALIZE_BUFFER(write_ptr, object2.c_str(), __ros_object2_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, penetration_distance);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, operation);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_object1_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_object1_len);
    object1 = std::string((const char *)read_ptr, __ros_object1_len);
    read_ptr += __ros_object1_len;
    unsigned __ros_object2_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_object2_len);
    object2 = std::string((const char *)read_ptr, __ros_object2_len);
    read_ptr += __ros_object2_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, penetration_distance);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, operation);
    return read_ptr;
  }
};

typedef boost::shared_ptr<CollisionOperation> CollisionOperationPtr;
typedef boost::shared_ptr<CollisionOperation const> CollisionOperationConstPtr;


}

#endif
