/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/MotionPlanRequest.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_MOTIONPLANREQUEST_H
#define MOTION_PLANNING_MSGS_MOTIONPLANREQUEST_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "roslib/Header.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"
#include "motion_planning_msgs/WorkspaceParameters.h"
#include "sensor_msgs/JointState.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"
#include "motion_planning_msgs/JointConstraint.h"
#include "motion_planning_msgs/PositionConstraint.h"
#include "motion_planning_msgs/OrientationConstraint.h"
#include "motion_planning_msgs/Constraints.h"
#include "motion_planning_msgs/AllowedContactSpecification.h"
#include "motion_planning_msgs/CollisionOperation.h"
#include "motion_planning_msgs/OrderedCollisionOperations.h"

namespace motion_planning_msgs
{

//! \htmlinclude MotionPlanRequest.msg.html

class MotionPlanRequest : public ros::Message
{
public:
  typedef boost::shared_ptr<MotionPlanRequest> Ptr;
  typedef boost::shared_ptr<MotionPlanRequest const> ConstPtr;

  typedef motion_planning_msgs::WorkspaceParameters _workspace_parameters_type;
  typedef motion_planning_msgs::RobotState _start_state_type;
  typedef motion_planning_msgs::Constraints _goal_constraints_type;
  typedef motion_planning_msgs::Constraints _path_constraints_type;
  typedef std::vector<motion_planning_msgs::AllowedContactSpecification> _allowed_contacts_type;
  typedef motion_planning_msgs::OrderedCollisionOperations _ordered_collision_operations_type;
  typedef std::string _planner_id_type;
  typedef std::string _group_name_type;
  typedef int32_t _num_planning_attempts_type;
  typedef ros::Duration _allowed_planning_time_type;
  typedef ros::Duration _expected_path_duration_type;
  typedef ros::Duration _expected_path_dt_type;

  motion_planning_msgs::WorkspaceParameters workspace_parameters;
  motion_planning_msgs::RobotState start_state;
  motion_planning_msgs::Constraints goal_constraints;
  motion_planning_msgs::Constraints path_constraints;
  std::vector<motion_planning_msgs::AllowedContactSpecification> allowed_contacts;
  motion_planning_msgs::OrderedCollisionOperations ordered_collision_operations;
  std::string planner_id;
  std::string group_name;
  int32_t num_planning_attempts;
  ros::Duration allowed_planning_time;
  ros::Duration expected_path_duration;
  ros::Duration expected_path_dt;

  MotionPlanRequest() : ros::Message(),
    num_planning_attempts(0)
  {
  }
  MotionPlanRequest(const MotionPlanRequest &copy) : ros::Message(),
    workspace_parameters(copy.workspace_parameters),
    start_state(copy.start_state),
    goal_constraints(copy.goal_constraints),
    path_constraints(copy.path_constraints),
    ordered_collision_operations(copy.ordered_collision_operations),
    planner_id(copy.planner_id),
    group_name(copy.group_name),
    num_planning_attempts(copy.num_planning_attempts),
    allowed_planning_time(copy.allowed_planning_time),
    expected_path_duration(copy.expected_path_duration),
    expected_path_dt(copy.expected_path_dt)
  {
    (void)copy;
    allowed_contacts = copy.allowed_contacts;
  }
  MotionPlanRequest &operator =(const MotionPlanRequest &copy)
  {
    if (this == &copy)
      return *this;
    allowed_contacts.clear();
    workspace_parameters = copy.workspace_parameters;
    start_state = copy.start_state;
    goal_constraints = copy.goal_constraints;
    path_constraints = copy.path_constraints;
    allowed_contacts = copy.allowed_contacts;
    ordered_collision_operations = copy.ordered_collision_operations;
    planner_id = copy.planner_id;
    group_name = copy.group_name;
    num_planning_attempts = copy.num_planning_attempts;
    allowed_planning_time = copy.allowed_planning_time;
    expected_path_duration = copy.expected_path_duration;
    expected_path_dt = copy.expected_path_dt;
    return *this;
  }
  virtual ~MotionPlanRequest() 
  {
    allowed_contacts.clear();
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/MotionPlanRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string("f312d62989edf442e404e69a0012d0b2"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This service contains the definition for a request to the motion\n"
    "# planner and the output it provides\n"
    "\n"
    "# Parameters for the workspace that the planner should work inside\n"
    "motion_planning_msgs/WorkspaceParameters workspace_parameters\n"
    "\n"
    "# Starting state updates. If certain joints should be considered\n"
    "# at positions other than the current ones, these positions should\n"
    "# be set here\n"
    "motion_planning_msgs/RobotState start_state\n"
    "\n"
    "# The goal state for the model to plan for. The goal is achieved\n"
    "# if all constraints are satisfied\n"
    "motion_planning_msgs/Constraints goal_constraints\n"
    "\n"
    "# No state at any point along the path in the produced motion plan will violate these constraints\n"
    "motion_planning_msgs/Constraints path_constraints\n"
    "\n"
    "# A specification for regions where contact is \n"
    "# allowed upto a certain depth\n"
    "# Any collision within this set of regions with a link \n"
    "# specified in the message will be allowed if\n"
    "# it is less than the penetration depth specified in the message\n"
    "AllowedContactSpecification[] allowed_contacts\n"
    "\n"
    "# A set of ordered collision operations, \n"
    "# these are applied to all links, objects, \n"
    "# namespaces in the collision space\n"
    "OrderedCollisionOperations ordered_collision_operations\n"
    "\n"
    "# The name of the motion planner to use. If no name is specified,\n"
    "# a default motion planner will be used\n"
    "string planner_id\n"
    "\n"
    "# The name of the group of joints on which this planner is operating\n"
    "string group_name\n"
    "\n"
    "# The number of times this plan is to be computed. Shortest solution\n"
    "# will be reported.\n"
    "int32 num_planning_attempts\n"
    "\n"
    "# The maximum amount of time the motion planner is allowed to plan for\n"
    "duration allowed_planning_time\n"
    "\n"
    "# An expected path duration (in seconds) along with an expected discretization of the path allows the planner to determine the discretization of the trajectory that it returns\n"
    "duration expected_path_duration\n"
    "duration expected_path_dt\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/WorkspaceParameters\n"
    "# This message contains a set of parameters useful in\n"
    "# setting up the workspace for planning\n"
    "geometric_shapes_msgs/Shape  workspace_region_shape\n"
    "geometry_msgs/PoseStamped    workspace_region_pose\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/Constraints\n"
    "# This message contains a list of motion planning constraints.\n"
    "\n"
    "motion_planning_msgs/JointConstraint[] joint_constraints\n"
    "motion_planning_msgs/PositionConstraint[] position_constraints\n"
    "motion_planning_msgs/OrientationConstraint[] orientation_constraints\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/JointConstraint\n"
    "# Constrain the position of a joint to be within a certain bound\n"
    "string joint_name\n"
    "\n"
    "# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n"
    "float64 position\n"
    "float64 tolerance_above\n"
    "float64 tolerance_below\n"
    "\n"
    "# A weighting factor for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/PositionConstraint\n"
    "# This message contains the definition of a position constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The offset (in the link frame) for the target point on the link we are planning for\n"
    "geometry_msgs/Point target_point_offset\n"
    "\n"
    "# The nominal/target position for the point we are planning for\n"
    "geometry_msgs/Point position\n"
    "\n"
    "# The shape of the bounded region that constrains the position of the end-effector\n"
    "# This region is always centered at the position defined above\n"
    "geometric_shapes_msgs/Shape constraint_region_shape\n"
    "\n"
    "# The orientation of the bounded region that constrains the position of the end-effector. \n"
    "# This allows the specification of non-axis aligned constraints\n"
    "geometry_msgs/Quaternion constraint_region_orientation\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/OrientationConstraint\n"
    "# This message contains the definition of an orientation constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The type of the constraint\n"
    "int32 type\n"
    "int32 LINK_FRAME=0\n"
    "int32 HEADER_FRAME=1\n"
    "\n"
    "# The desired orientation of the robot link specified as a quaternion\n"
    "geometry_msgs/Quaternion orientation\n"
    "\n"
    "# optional RPY error tolerances specified if \n"
    "float64 absolute_roll_tolerance\n"
    "float64 absolute_pitch_tolerance\n"
    "float64 absolute_yaw_tolerance\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/AllowedContactSpecification\n"
    "# The names of the regions\n"
    "string name\n"
    "\n"
    "# The shape of the region in the environment\n"
    "geometric_shapes_msgs/Shape shape\n"
    "\n"
    "# The pose of the space defining the region\n"
    "geometry_msgs/PoseStamped pose_stamped\n"
    "\n"
    "# The set of links that will be allowed to have penetration contact within this region\n"
    "string[] link_names\n"
    "\n"
    "# The maximum penetration depth allowed for every link\n"
    "float64 penetration_depth\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/OrderedCollisionOperations\n"
    "# A set of collision operations that will be performed in the order they are specified\n"
    "CollisionOperation[] collision_operations\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/CollisionOperation\n"
    "# A definition of a collision operation\n"
    "# E.g. (\"gripper\",COLLISION_SET_ALL,ENABLE) will enable collisions \n"
    "# between the gripper and all objects in the collision space\n"
    "\n"
    "string object1\n"
    "string object2\n"
    "string COLLISION_SET_ALL=\"all\"\n"
    "string COLLISION_SET_OBJECTS=\"objects\"\n"
    "string COLLISION_SET_ATTACHED_OBJECTS=\"attached\"\n"
    "\n"
    "# The penetration distance to which collisions are allowed. This is 0.0 by default.\n"
    "float64 penetration_distance\n"
    "\n"
    "# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above\n"
    "int32 operation\n"
    "int32 DISABLE=0\n"
    "int32 ENABLE=1\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_allowed_contacts_size(uint32_t __ros_new_size)
  {
    this->allowed_contacts.resize(__ros_new_size);
  }
  inline uint32_t get_allowed_contacts_size() const { return allowed_contacts.size(); }
  uint32_t calc_allowed_contacts_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t allowed_contacts_size = allowed_contacts.size();
    for (size_t i = 0; i < allowed_contacts_size; i++)
      l += allowed_contacts[i].serializationLength();
    return l;
  }
  inline void get_allowed_contacts_vec (std::vector<motion_planning_msgs::AllowedContactSpecification> &__ros_vec) const
  {
    __ros_vec = this->allowed_contacts;
  }
  inline void set_allowed_contacts_vec(const std::vector<motion_planning_msgs::AllowedContactSpecification> &__ros_vec)
  {
    this->allowed_contacts = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += workspace_parameters.serializationLength(); // workspace_parameters
    __l += start_state.serializationLength(); // start_state
    __l += goal_constraints.serializationLength(); // goal_constraints
    __l += path_constraints.serializationLength(); // path_constraints
    __l += 4 + calc_allowed_contacts_array_serialization_len(); // allowed_contacts
    __l += ordered_collision_operations.serializationLength(); // ordered_collision_operations
    __l += 4 + planner_id.length(); // planner_id
    __l += 4 + group_name.length(); // group_name
    __l += 4; // num_planning_attempts
    __l += 8; // allowed_planning_time
    __l += 8; // expected_path_duration
    __l += 8; // expected_path_dt
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = workspace_parameters.serialize(write_ptr, seq);
    write_ptr = start_state.serialize(write_ptr, seq);
    write_ptr = goal_constraints.serialize(write_ptr, seq);
    write_ptr = path_constraints.serialize(write_ptr, seq);
    uint32_t __allowed_contacts_size = allowed_contacts.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __allowed_contacts_size);
    for (size_t i = 0; i < __allowed_contacts_size; i++)
      write_ptr = allowed_contacts[i].serialize(write_ptr, seq);
    write_ptr = ordered_collision_operations.serialize(write_ptr, seq);
    unsigned __ros_planner_id_len = planner_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_planner_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, planner_id.c_str(), __ros_planner_id_len);
    unsigned __ros_group_name_len = group_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_group_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, group_name.c_str(), __ros_group_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_planning_attempts);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, allowed_planning_time.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, allowed_planning_time.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, expected_path_duration.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, expected_path_duration.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, expected_path_dt.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, expected_path_dt.nsec);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = workspace_parameters.deserialize(read_ptr);
    read_ptr = start_state.deserialize(read_ptr);
    read_ptr = goal_constraints.deserialize(read_ptr);
    read_ptr = path_constraints.deserialize(read_ptr);
    uint32_t __allowed_contacts_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __allowed_contacts_size);
    set_allowed_contacts_size(__allowed_contacts_size);
    for (size_t i = 0; i < __allowed_contacts_size; i++)
      read_ptr = allowed_contacts[i].deserialize(read_ptr);
    read_ptr = ordered_collision_operations.deserialize(read_ptr);
    unsigned __ros_planner_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_planner_id_len);
    planner_id = std::string((const char *)read_ptr, __ros_planner_id_len);
    read_ptr += __ros_planner_id_len;
    unsigned __ros_group_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_group_name_len);
    group_name = std::string((const char *)read_ptr, __ros_group_name_len);
    read_ptr += __ros_group_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_planning_attempts);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, allowed_planning_time.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, allowed_planning_time.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, expected_path_duration.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, expected_path_duration.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, expected_path_dt.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, expected_path_dt.nsec);
    return read_ptr;
  }
};

typedef boost::shared_ptr<MotionPlanRequest> MotionPlanRequestPtr;
typedef boost::shared_ptr<MotionPlanRequest const> MotionPlanRequestConstPtr;


}

#endif
