/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/MultiDOFJointState.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_MULTIDOFJOINTSTATE_H
#define MOTION_PLANNING_MSGS_MULTIDOFJOINTSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace motion_planning_msgs
{

//! \htmlinclude MultiDOFJointState.msg.html

class MultiDOFJointState : public ros::Message
{
public:
  typedef boost::shared_ptr<MultiDOFJointState> Ptr;
  typedef boost::shared_ptr<MultiDOFJointState const> ConstPtr;

  typedef ros::Time _stamp_type;
  typedef std::string _joint_name_type;
  typedef std::string _frame_id_type;
  typedef std::string _child_frame_id_type;
  typedef geometry_msgs::Pose _pose_type;

  ros::Time stamp;
  std::string joint_name;
  std::string frame_id;
  std::string child_frame_id;
  geometry_msgs::Pose pose;

  MultiDOFJointState() : ros::Message()
  {
  }
  MultiDOFJointState(const MultiDOFJointState &copy) : ros::Message(),
    stamp(copy.stamp),
    joint_name(copy.joint_name),
    frame_id(copy.frame_id),
    child_frame_id(copy.child_frame_id),
    pose(copy.pose)
  {
    (void)copy;
  }
  MultiDOFJointState &operator =(const MultiDOFJointState &copy)
  {
    if (this == &copy)
      return *this;
    stamp = copy.stamp;
    joint_name = copy.joint_name;
    frame_id = copy.frame_id;
    child_frame_id = copy.child_frame_id;
    pose = copy.pose;
    return *this;
  }
  virtual ~MultiDOFJointState() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/MultiDOFJointState"); }
  inline static std::string __s_getMD5Sum() { return std::string("aa076366f19095c1b2fc35d9e92f8270"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 8; // stamp
    __l += 4 + joint_name.length(); // joint_name
    __l += 4 + frame_id.length(); // frame_id
    __l += 4 + child_frame_id.length(); // child_frame_id
    __l += pose.serializationLength(); // pose
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, stamp.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, stamp.nsec);
    unsigned __ros_joint_name_len = joint_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_name.c_str(), __ros_joint_name_len);
    unsigned __ros_frame_id_len = frame_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_frame_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, frame_id.c_str(), __ros_frame_id_len);
    unsigned __ros_child_frame_id_len = child_frame_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_child_frame_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, child_frame_id.c_str(), __ros_child_frame_id_len);
    write_ptr = pose.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, stamp.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, stamp.nsec);
    unsigned __ros_joint_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_name_len);
    joint_name = std::string((const char *)read_ptr, __ros_joint_name_len);
    read_ptr += __ros_joint_name_len;
    unsigned __ros_frame_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_frame_id_len);
    frame_id = std::string((const char *)read_ptr, __ros_frame_id_len);
    read_ptr += __ros_frame_id_len;
    unsigned __ros_child_frame_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_child_frame_id_len);
    child_frame_id = std::string((const char *)read_ptr, __ros_child_frame_id_len);
    read_ptr += __ros_child_frame_id_len;
    read_ptr = pose.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<MultiDOFJointState> MultiDOFJointStatePtr;
typedef boost::shared_ptr<MultiDOFJointState const> MultiDOFJointStateConstPtr;


}

#endif
