/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/PositionConstraint.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_POSITIONCONSTRAINT_H
#define MOTION_PLANNING_MSGS_POSITIONCONSTRAINT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "geometry_msgs/Quaternion.h"

namespace motion_planning_msgs
{

//! \htmlinclude PositionConstraint.msg.html

class PositionConstraint : public ros::Message
{
public:
  typedef boost::shared_ptr<PositionConstraint> Ptr;
  typedef boost::shared_ptr<PositionConstraint const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _link_name_type;
  typedef geometry_msgs::Point _target_point_offset_type;
  typedef geometry_msgs::Point _position_type;
  typedef geometric_shapes_msgs::Shape _constraint_region_shape_type;
  typedef geometry_msgs::Quaternion _constraint_region_orientation_type;
  typedef double _weight_type;

  roslib::Header header;
  std::string link_name;
  geometry_msgs::Point target_point_offset;
  geometry_msgs::Point position;
  geometric_shapes_msgs::Shape constraint_region_shape;
  geometry_msgs::Quaternion constraint_region_orientation;
  double weight;

  PositionConstraint() : ros::Message(),
    weight(0)
  {
  }
  PositionConstraint(const PositionConstraint &copy) : ros::Message(),
    header(copy.header),
    link_name(copy.link_name),
    target_point_offset(copy.target_point_offset),
    position(copy.position),
    constraint_region_shape(copy.constraint_region_shape),
    constraint_region_orientation(copy.constraint_region_orientation),
    weight(copy.weight)
  {
    (void)copy;
  }
  PositionConstraint &operator =(const PositionConstraint &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    link_name = copy.link_name;
    target_point_offset = copy.target_point_offset;
    position = copy.position;
    constraint_region_shape = copy.constraint_region_shape;
    constraint_region_orientation = copy.constraint_region_orientation;
    weight = copy.weight;
    return *this;
  }
  virtual ~PositionConstraint() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/PositionConstraint"); }
  inline static std::string __s_getMD5Sum() { return std::string("7e3d9697e64b346b9d3cb7311bb88ccb"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains the definition of a position constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The offset (in the link frame) for the target point on the link we are planning for\n"
    "geometry_msgs/Point target_point_offset\n"
    "\n"
    "# The nominal/target position for the point we are planning for\n"
    "geometry_msgs/Point position\n"
    "\n"
    "# The shape of the bounded region that constrains the position of the end-effector\n"
    "# This region is always centered at the position defined above\n"
    "geometric_shapes_msgs/Shape constraint_region_shape\n"
    "\n"
    "# The orientation of the bounded region that constrains the position of the end-effector. \n"
    "# This allows the specification of non-axis aligned constraints\n"
    "geometry_msgs/Quaternion constraint_region_orientation\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + link_name.length(); // link_name
    __l += target_point_offset.serializationLength(); // target_point_offset
    __l += position.serializationLength(); // position
    __l += constraint_region_shape.serializationLength(); // constraint_region_shape
    __l += constraint_region_orientation.serializationLength(); // constraint_region_orientation
    __l += 8; // weight
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_link_name_len = link_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_link_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, link_name.c_str(), __ros_link_name_len);
    write_ptr = target_point_offset.serialize(write_ptr, seq);
    write_ptr = position.serialize(write_ptr, seq);
    write_ptr = constraint_region_shape.serialize(write_ptr, seq);
    write_ptr = constraint_region_orientation.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, weight);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_link_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_link_name_len);
    link_name = std::string((const char *)read_ptr, __ros_link_name_len);
    read_ptr += __ros_link_name_len;
    read_ptr = target_point_offset.deserialize(read_ptr);
    read_ptr = position.deserialize(read_ptr);
    read_ptr = constraint_region_shape.deserialize(read_ptr);
    read_ptr = constraint_region_orientation.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, weight);
    return read_ptr;
  }
};

typedef boost::shared_ptr<PositionConstraint> PositionConstraintPtr;
typedef boost::shared_ptr<PositionConstraint const> PositionConstraintConstPtr;


}

#endif
