/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/SimplePoseConstraint.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_SIMPLEPOSECONSTRAINT_H
#define MOTION_PLANNING_MSGS_SIMPLEPOSECONSTRAINT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace motion_planning_msgs
{

//! \htmlinclude SimplePoseConstraint.msg.html

class SimplePoseConstraint : public ros::Message
{
public:
  typedef boost::shared_ptr<SimplePoseConstraint> Ptr;
  typedef boost::shared_ptr<SimplePoseConstraint const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _link_name_type;
  typedef geometry_msgs::Pose _pose_type;
  typedef geometry_msgs::Point _absolute_position_tolerance_type;
  typedef double _absolute_roll_tolerance_type;
  typedef double _absolute_yaw_tolerance_type;
  typedef double _absolute_pitch_tolerance_type;
  typedef int32_t _orientation_constraint_type_type;

  roslib::Header header;
  std::string link_name;
  geometry_msgs::Pose pose;
  geometry_msgs::Point absolute_position_tolerance;
  double absolute_roll_tolerance;
  double absolute_yaw_tolerance;
  double absolute_pitch_tolerance;
  int32_t orientation_constraint_type;
  const static int32_t HEADER_FRAME = 0;
  const static int32_t LINK_FRAME = 1;

  SimplePoseConstraint() : ros::Message(),
    absolute_roll_tolerance(0),
    absolute_yaw_tolerance(0),
    absolute_pitch_tolerance(0),
    orientation_constraint_type(0)
  {
  }
  SimplePoseConstraint(const SimplePoseConstraint &copy) : ros::Message(),
    header(copy.header),
    link_name(copy.link_name),
    pose(copy.pose),
    absolute_position_tolerance(copy.absolute_position_tolerance),
    absolute_roll_tolerance(copy.absolute_roll_tolerance),
    absolute_yaw_tolerance(copy.absolute_yaw_tolerance),
    absolute_pitch_tolerance(copy.absolute_pitch_tolerance),
    orientation_constraint_type(copy.orientation_constraint_type)
  {
    (void)copy;
  }
  SimplePoseConstraint &operator =(const SimplePoseConstraint &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    link_name = copy.link_name;
    pose = copy.pose;
    absolute_position_tolerance = copy.absolute_position_tolerance;
    absolute_roll_tolerance = copy.absolute_roll_tolerance;
    absolute_yaw_tolerance = copy.absolute_yaw_tolerance;
    absolute_pitch_tolerance = copy.absolute_pitch_tolerance;
    orientation_constraint_type = copy.orientation_constraint_type;
    return *this;
  }
  virtual ~SimplePoseConstraint() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/SimplePoseConstraint"); }
  inline static std::string __s_getMD5Sum() { return std::string("3483d830eb84ecd3059741fd417b30da"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains the definition of a simple pose constraint \n"
    "# that specifies the pose for a particular link of the robot and corresponding\n"
    "# (absolute) position and orientation tolerances\n"
    "\n"
    "# The standard ROS message header\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The desired position of the robot link\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "# Position (absolute) tolerance\n"
    "geometry_msgs/Point absolute_position_tolerance\n"
    "\n"
    "# Orientation (absolute) tolerance\n"
    "float64 absolute_roll_tolerance\n"
    "float64 absolute_yaw_tolerance\n"
    "float64 absolute_pitch_tolerance\n"
    "\n"
    "int32 orientation_constraint_type\n"
    "int32 HEADER_FRAME=0\n"
    "int32 LINK_FRAME=1\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + link_name.length(); // link_name
    __l += pose.serializationLength(); // pose
    __l += absolute_position_tolerance.serializationLength(); // absolute_position_tolerance
    __l += 8; // absolute_roll_tolerance
    __l += 8; // absolute_yaw_tolerance
    __l += 8; // absolute_pitch_tolerance
    __l += 4; // orientation_constraint_type
    __l += 0; // HEADER_FRAME
    __l += 0; // LINK_FRAME
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_link_name_len = link_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_link_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, link_name.c_str(), __ros_link_name_len);
    write_ptr = pose.serialize(write_ptr, seq);
    write_ptr = absolute_position_tolerance.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, absolute_roll_tolerance);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, absolute_yaw_tolerance);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, absolute_pitch_tolerance);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, orientation_constraint_type);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_link_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_link_name_len);
    link_name = std::string((const char *)read_ptr, __ros_link_name_len);
    read_ptr += __ros_link_name_len;
    read_ptr = pose.deserialize(read_ptr);
    read_ptr = absolute_position_tolerance.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, absolute_roll_tolerance);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, absolute_yaw_tolerance);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, absolute_pitch_tolerance);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, orientation_constraint_type);
    return read_ptr;
  }
};

typedef boost::shared_ptr<SimplePoseConstraint> SimplePoseConstraintPtr;
typedef boost::shared_ptr<SimplePoseConstraint const> SimplePoseConstraintConstPtr;


}

#endif
