/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/WorkspaceParameters.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_WORKSPACEPARAMETERS_H
#define MOTION_PLANNING_MSGS_WORKSPACEPARAMETERS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "roslib/Header.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"

namespace motion_planning_msgs
{

//! \htmlinclude WorkspaceParameters.msg.html

class WorkspaceParameters : public ros::Message
{
public:
  typedef boost::shared_ptr<WorkspaceParameters> Ptr;
  typedef boost::shared_ptr<WorkspaceParameters const> ConstPtr;

  typedef geometric_shapes_msgs::Shape _workspace_region_shape_type;
  typedef geometry_msgs::PoseStamped _workspace_region_pose_type;

  geometric_shapes_msgs::Shape workspace_region_shape;
  geometry_msgs::PoseStamped workspace_region_pose;

  WorkspaceParameters() : ros::Message()
  {
  }
  WorkspaceParameters(const WorkspaceParameters &copy) : ros::Message(),
    workspace_region_shape(copy.workspace_region_shape),
    workspace_region_pose(copy.workspace_region_pose)
  {
    (void)copy;
  }
  WorkspaceParameters &operator =(const WorkspaceParameters &copy)
  {
    if (this == &copy)
      return *this;
    workspace_region_shape = copy.workspace_region_shape;
    workspace_region_pose = copy.workspace_region_pose;
    return *this;
  }
  virtual ~WorkspaceParameters() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/WorkspaceParameters"); }
  inline static std::string __s_getMD5Sum() { return std::string("1487490edff0df276863abf2cf221de5"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains a set of parameters useful in\n"
    "# setting up the workspace for planning\n"
    "geometric_shapes_msgs/Shape  workspace_region_shape\n"
    "geometry_msgs/PoseStamped    workspace_region_pose\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += workspace_region_shape.serializationLength(); // workspace_region_shape
    __l += workspace_region_pose.serializationLength(); // workspace_region_pose
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = workspace_region_shape.serialize(write_ptr, seq);
    write_ptr = workspace_region_pose.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = workspace_region_shape.deserialize(read_ptr);
    read_ptr = workspace_region_pose.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<WorkspaceParameters> WorkspaceParametersPtr;
typedef boost::shared_ptr<WorkspaceParameters const> WorkspaceParametersConstPtr;


}

#endif
