# autogenerated by genmsg_py from AllowedContactSpecification.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import geometric_shapes_msgs.msg

class AllowedContactSpecification(roslib.message.Message):
  _md5sum = "81f9b47ac49a467ae008d3d9485628a3"
  _type = "motion_planning_msgs/AllowedContactSpecification"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# The names of the regions
string name

# The shape of the region in the environment
geometric_shapes_msgs/Shape shape

# The pose of the space defining the region
geometry_msgs/PoseStamped pose_stamped

# The set of links that will be allowed to have penetration contact within this region
string[] link_names

# The maximum penetration depth allowed for every link
float64 penetration_depth
================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['name','shape','pose_stamped','link_names','penetration_depth']
  _slot_types = ['string','geometric_shapes_msgs/Shape','geometry_msgs/PoseStamped','string[]','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   name,shape,pose_stamped,link_names,penetration_depth
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(AllowedContactSpecification, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.shape is None:
        self.shape = geometric_shapes_msgs.msg.Shape()
      if self.pose_stamped is None:
        self.pose_stamped = geometry_msgs.msg.PoseStamped()
      if self.link_names is None:
        self.link_names = []
      if self.penetration_depth is None:
        self.penetration_depth = 0.
    else:
      self.name = ''
      self.shape = geometric_shapes_msgs.msg.Shape()
      self.pose_stamped = geometry_msgs.msg.PoseStamped()
      self.link_names = []
      self.penetration_depth = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<b', self.shape.type))
      #serialize self.shape.dimensions
      length = len(self.shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.shape.dimensions))
      #serialize self.shape.triangles
      length = len(self.shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.shape.triangles))
      #serialize self.shape.vertices
      length = len(self.shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.pose_stamped.header.seq, self.pose_stamped.header.stamp.secs, self.pose_stamped.header.stamp.nsecs))
      length = len(self.pose_stamped.header.frame_id)
      #serialize self.pose_stamped.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose_stamped.header.frame_id))
      buff.write(struct.pack('<7d', self.pose_stamped.pose.position.x, self.pose_stamped.pose.position.y, self.pose_stamped.pose.position.z, self.pose_stamped.pose.orientation.x, self.pose_stamped.pose.orientation.y, self.pose_stamped.pose.orientation.z, self.pose_stamped.pose.orientation.w))
      #serialize self.link_names
      length = len(self.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      buff.write(struct.pack('<d', self.penetration_depth))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.shape is None:
        self.shape = geometric_shapes_msgs.msg.Shape()
      if self.pose_stamped is None:
        self.pose_stamped = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.shape.dimensions = struct.unpack(pattern, str[start:end])
      #deserialize self.shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.shape.triangles = struct.unpack(pattern, str[start:end])
      #deserialize self.shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.shape.vertices.append(val1)
      start = end
      end += 12
      (self.pose_stamped.header.seq, self.pose_stamped.header.stamp.secs, self.pose_stamped.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose_stamped.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.pose_stamped.pose.position.x, self.pose_stamped.pose.position.y, self.pose_stamped.pose.position.z, self.pose_stamped.pose.orientation.x, self.pose_stamped.pose.orientation.y, self.pose_stamped.pose.orientation.z, self.pose_stamped.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.link_names.append(val1)
      start = end
      end += 8
      (self.penetration_depth,) = struct.unpack('<d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.name)
      #serialize self.name
      buff.write(struct.pack('<I%ss'%length, length, self.name))
      buff.write(struct.pack('<b', self.shape.type))
      #serialize self.shape.dimensions
      length = len(self.shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.shape.dimensions.tostring())
      #serialize self.shape.triangles
      length = len(self.shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(self.shape.triangles.tostring())
      #serialize self.shape.vertices
      length = len(self.shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.pose_stamped.header.seq, self.pose_stamped.header.stamp.secs, self.pose_stamped.header.stamp.nsecs))
      length = len(self.pose_stamped.header.frame_id)
      #serialize self.pose_stamped.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose_stamped.header.frame_id))
      buff.write(struct.pack('<7d', self.pose_stamped.pose.position.x, self.pose_stamped.pose.position.y, self.pose_stamped.pose.position.z, self.pose_stamped.pose.orientation.x, self.pose_stamped.pose.orientation.y, self.pose_stamped.pose.orientation.z, self.pose_stamped.pose.orientation.w))
      #serialize self.link_names
      length = len(self.link_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.link_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      buff.write(struct.pack('<d', self.penetration_depth))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.shape is None:
        self.shape = geometric_shapes_msgs.msg.Shape()
      if self.pose_stamped is None:
        self.pose_stamped = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      #deserialize self.shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.shape.vertices.append(val1)
      start = end
      end += 12
      (self.pose_stamped.header.seq, self.pose_stamped.header.stamp.secs, self.pose_stamped.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose_stamped.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.pose_stamped.pose.position.x, self.pose_stamped.pose.position.y, self.pose_stamped.pose.position.z, self.pose_stamped.pose.orientation.x, self.pose_stamped.pose.orientation.y, self.pose_stamped.pose.orientation.z, self.pose_stamped.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.link_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.link_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.link_names.append(val1)
      start = end
      end += 8
      (self.penetration_depth,) = struct.unpack('<d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

