# autogenerated by genmsg_py from Constraints.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import geometry_msgs.msg
import motion_planning_msgs.msg
import geometric_shapes_msgs.msg

class Constraints(roslib.message.Message):
  _md5sum = "b40cc0b03d3b7699bb93ad0fdb8a7245"
  _type = "motion_planning_msgs/Constraints"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message contains a list of motion planning constraints.

motion_planning_msgs/JointConstraint[] joint_constraints
motion_planning_msgs/PositionConstraint[] position_constraints
motion_planning_msgs/OrientationConstraint[] orientation_constraints

================================================================================
MSG: motion_planning_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/PositionConstraint
# This message contains the definition of a position constraint.
Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Point target_point_offset

# The nominal/target position for the point we are planning for
geometry_msgs/Point position

# The shape of the bounded region that constrains the position of the end-effector
# This region is always centered at the position defined above
geometric_shapes_msgs/Shape constraint_region_shape

# The orientation of the bounded region that constrains the position of the end-effector. 
# This allows the specification of non-axis aligned constraints
geometry_msgs/Quaternion constraint_region_orientation

# Constraint weighting factor - a weight for this constraint
float64 weight
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.
Header header

# The robot link this constraint refers to
string link_name

# The type of the constraint
int32 type
int32 LINK_FRAME=0
int32 HEADER_FRAME=1

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# optional RPY error tolerances specified if 
float64 absolute_roll_tolerance
float64 absolute_pitch_tolerance
float64 absolute_yaw_tolerance

# Constraint weighting factor - a weight for this constraint
float64 weight

"""
  __slots__ = ['joint_constraints','position_constraints','orientation_constraints']
  _slot_types = ['motion_planning_msgs/JointConstraint[]','motion_planning_msgs/PositionConstraint[]','motion_planning_msgs/OrientationConstraint[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   joint_constraints,position_constraints,orientation_constraints
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(Constraints, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_constraints is None:
        self.joint_constraints = []
      if self.position_constraints is None:
        self.position_constraints = []
      if self.orientation_constraints is None:
        self.orientation_constraints = []
    else:
      self.joint_constraints = []
      self.position_constraints = []
      self.orientation_constraints = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.joint_constraints
      length = len(self.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.position_constraints
      length = len(self.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.dimensions))
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.triangles))
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.orientation_constraints
      length = len(self.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.joint_constraints.append(val1)
      #deserialize self.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.position_constraints.append(val1)
      #deserialize self.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.orientation_constraints.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.joint_constraints
      length = len(self.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.position_constraints
      length = len(self.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.constraint_region_shape.dimensions.tostring())
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.constraint_region_shape.triangles.tostring())
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.orientation_constraints
      length = len(self.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.joint_constraints.append(val1)
      #deserialize self.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.position_constraints.append(val1)
      #deserialize self.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.orientation_constraints.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

