# autogenerated by genmsg_py from JointConstraint.msg. Do not edit.
import roslib.message
import struct


class JointConstraint(roslib.message.Message):
  _md5sum = "c02a15146bec0ce13564807805b008f0"
  _type = "motion_planning_msgs/JointConstraint"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
"""
  __slots__ = ['joint_name','position','tolerance_above','tolerance_below','weight']
  _slot_types = ['string','float64','float64','float64','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   joint_name,position,tolerance_above,tolerance_below,weight
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(JointConstraint, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_name is None:
        self.joint_name = ''
      if self.position is None:
        self.position = 0.
      if self.tolerance_above is None:
        self.tolerance_above = 0.
      if self.tolerance_below is None:
        self.tolerance_below = 0.
      if self.weight is None:
        self.weight = 0.
    else:
      self.joint_name = ''
      self.position = 0.
      self.tolerance_above = 0.
      self.tolerance_below = 0.
      self.weight = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.joint_name)
      #serialize self.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.joint_name))
      buff.write(struct.pack('<4d', self.position, self.tolerance_above, self.tolerance_below, self.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.position, self.tolerance_above, self.tolerance_below, self.weight,) = struct.unpack('<4d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.joint_name)
      #serialize self.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.joint_name))
      buff.write(struct.pack('<4d', self.position, self.tolerance_above, self.tolerance_below, self.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.position, self.tolerance_above, self.tolerance_below, self.weight,) = struct.unpack('<4d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

