# autogenerated by genmsg_py from JointLimits.msg. Do not edit.
import roslib.message
import struct


class JointLimits(roslib.message.Message):
  _md5sum = "c3664ae4e985c5c886bfcffcbc6f1044"
  _type = "motion_planning_msgs/JointLimits"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message contains information about limits of a particular joint (or control dimension)
string joint_name

# true if the joint has position limits
uint8 has_position_limits

# min and max position limits
float64 min_position
float64 max_position

# true if joint has velocity limits
uint8 has_velocity_limits

# max velocity limit
float64 max_velocity
# min_velocity is assumed to be -max_velocity

# true if joint has acceleration limits
uint8 has_acceleration_limits
# max acceleration limit
float64 max_acceleration
# min_acceleration is assumed to be -max_acceleration

"""
  __slots__ = ['joint_name','has_position_limits','min_position','max_position','has_velocity_limits','max_velocity','has_acceleration_limits','max_acceleration']
  _slot_types = ['string','uint8','float64','float64','uint8','float64','uint8','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   joint_name,has_position_limits,min_position,max_position,has_velocity_limits,max_velocity,has_acceleration_limits,max_acceleration
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(JointLimits, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_name is None:
        self.joint_name = ''
      if self.has_position_limits is None:
        self.has_position_limits = 0
      if self.min_position is None:
        self.min_position = 0.
      if self.max_position is None:
        self.max_position = 0.
      if self.has_velocity_limits is None:
        self.has_velocity_limits = 0
      if self.max_velocity is None:
        self.max_velocity = 0.
      if self.has_acceleration_limits is None:
        self.has_acceleration_limits = 0
      if self.max_acceleration is None:
        self.max_acceleration = 0.
    else:
      self.joint_name = ''
      self.has_position_limits = 0
      self.min_position = 0.
      self.max_position = 0.
      self.has_velocity_limits = 0
      self.max_velocity = 0.
      self.has_acceleration_limits = 0
      self.max_acceleration = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.joint_name)
      #serialize self.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.joint_name))
      buff.write(struct.pack('<B2dBdBd', self.has_position_limits, self.min_position, self.max_position, self.has_velocity_limits, self.max_velocity, self.has_acceleration_limits, self.max_acceleration))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 35
      (self.has_position_limits, self.min_position, self.max_position, self.has_velocity_limits, self.max_velocity, self.has_acceleration_limits, self.max_acceleration,) = struct.unpack('<B2dBdBd',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.joint_name)
      #serialize self.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.joint_name))
      buff.write(struct.pack('<B2dBdBd', self.has_position_limits, self.min_position, self.max_position, self.has_velocity_limits, self.max_velocity, self.has_acceleration_limits, self.max_acceleration))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 35
      (self.has_position_limits, self.min_position, self.max_position, self.has_velocity_limits, self.max_velocity, self.has_acceleration_limits, self.max_acceleration,) = struct.unpack('<B2dBdBd',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

