# autogenerated by genmsg_py from OrderedCollisionOperations.msg. Do not edit.
import roslib.message
import struct

import motion_planning_msgs.msg

class OrderedCollisionOperations(roslib.message.Message):
  _md5sum = "f171f973b185d4d0121795080114026a"
  _type = "motion_planning_msgs/OrderedCollisionOperations"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# A set of collision operations that will be performed in the order they are specified
CollisionOperation[] collision_operations
================================================================================
MSG: motion_planning_msgs/CollisionOperation
# A definition of a collision operation
# E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
# between the gripper and all objects in the collision space

string object1
string object2
string COLLISION_SET_ALL="all"
string COLLISION_SET_OBJECTS="objects"
string COLLISION_SET_ATTACHED_OBJECTS="attached"

# The penetration distance to which collisions are allowed. This is 0.0 by default.
float64 penetration_distance

# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
int32 operation
int32 DISABLE=0
int32 ENABLE=1

"""
  __slots__ = ['collision_operations']
  _slot_types = ['motion_planning_msgs/CollisionOperation[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   collision_operations
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(OrderedCollisionOperations, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.collision_operations is None:
        self.collision_operations = []
    else:
      self.collision_operations = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.collision_operations
      length = len(self.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.collision_operations.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.collision_operations
      length = len(self.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.collision_operations.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

