# autogenerated by genmsg_py from PositionConstraint.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import geometric_shapes_msgs.msg

class PositionConstraint(roslib.message.Message):
  _md5sum = "7e3d9697e64b346b9d3cb7311bb88ccb"
  _type = "motion_planning_msgs/PositionConstraint"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message contains the definition of a position constraint.
Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Point target_point_offset

# The nominal/target position for the point we are planning for
geometry_msgs/Point position

# The shape of the bounded region that constrains the position of the end-effector
# This region is always centered at the position defined above
geometric_shapes_msgs/Shape constraint_region_shape

# The orientation of the bounded region that constrains the position of the end-effector. 
# This allows the specification of non-axis aligned constraints
geometry_msgs/Quaternion constraint_region_orientation

# Constraint weighting factor - a weight for this constraint
float64 weight
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['header','link_name','target_point_offset','position','constraint_region_shape','constraint_region_orientation','weight']
  _slot_types = ['Header','string','geometry_msgs/Point','geometry_msgs/Point','geometric_shapes_msgs/Shape','geometry_msgs/Quaternion','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,link_name,target_point_offset,position,constraint_region_shape,constraint_region_orientation,weight
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(PositionConstraint, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.link_name is None:
        self.link_name = ''
      if self.target_point_offset is None:
        self.target_point_offset = geometry_msgs.msg.Point()
      if self.position is None:
        self.position = geometry_msgs.msg.Point()
      if self.constraint_region_shape is None:
        self.constraint_region_shape = geometric_shapes_msgs.msg.Shape()
      if self.constraint_region_orientation is None:
        self.constraint_region_orientation = geometry_msgs.msg.Quaternion()
      if self.weight is None:
        self.weight = 0.
    else:
      self.header = roslib.msg._Header.Header()
      self.link_name = ''
      self.target_point_offset = geometry_msgs.msg.Point()
      self.position = geometry_msgs.msg.Point()
      self.constraint_region_shape = geometric_shapes_msgs.msg.Shape()
      self.constraint_region_orientation = geometry_msgs.msg.Quaternion()
      self.weight = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.link_name)
      #serialize self.link_name
      buff.write(struct.pack('<I%ss'%length, length, self.link_name))
      buff.write(struct.pack('<6db', self.target_point_offset.x, self.target_point_offset.y, self.target_point_offset.z, self.position.x, self.position.y, self.position.z, self.constraint_region_shape.type))
      #serialize self.constraint_region_shape.dimensions
      length = len(self.constraint_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.constraint_region_shape.dimensions))
      #serialize self.constraint_region_shape.triangles
      length = len(self.constraint_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.constraint_region_shape.triangles))
      #serialize self.constraint_region_shape.vertices
      length = len(self.constraint_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraint_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<5d', self.constraint_region_orientation.x, self.constraint_region_orientation.y, self.constraint_region_orientation.z, self.constraint_region_orientation.w, self.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.target_point_offset is None:
        self.target_point_offset = geometry_msgs.msg.Point()
      if self.position is None:
        self.position = geometry_msgs.msg.Point()
      if self.constraint_region_shape is None:
        self.constraint_region_shape = geometric_shapes_msgs.msg.Shape()
      if self.constraint_region_orientation is None:
        self.constraint_region_orientation = geometry_msgs.msg.Quaternion()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.link_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.link_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 49
      (self.target_point_offset.x, self.target_point_offset.y, self.target_point_offset.z, self.position.x, self.position.y, self.position.z, self.constraint_region_shape.type,) = struct.unpack('<6db',str[start:end])
      #deserialize self.constraint_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
      #deserialize self.constraint_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
      #deserialize self.constraint_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraint_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.constraint_region_shape.vertices.append(val1)
      start = end
      end += 40
      (self.constraint_region_orientation.x, self.constraint_region_orientation.y, self.constraint_region_orientation.z, self.constraint_region_orientation.w, self.weight,) = struct.unpack('<5d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.link_name)
      #serialize self.link_name
      buff.write(struct.pack('<I%ss'%length, length, self.link_name))
      buff.write(struct.pack('<6db', self.target_point_offset.x, self.target_point_offset.y, self.target_point_offset.z, self.position.x, self.position.y, self.position.z, self.constraint_region_shape.type))
      #serialize self.constraint_region_shape.dimensions
      length = len(self.constraint_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.constraint_region_shape.dimensions.tostring())
      #serialize self.constraint_region_shape.triangles
      length = len(self.constraint_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(self.constraint_region_shape.triangles.tostring())
      #serialize self.constraint_region_shape.vertices
      length = len(self.constraint_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraint_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<5d', self.constraint_region_orientation.x, self.constraint_region_orientation.y, self.constraint_region_orientation.z, self.constraint_region_orientation.w, self.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.target_point_offset is None:
        self.target_point_offset = geometry_msgs.msg.Point()
      if self.position is None:
        self.position = geometry_msgs.msg.Point()
      if self.constraint_region_shape is None:
        self.constraint_region_shape = geometric_shapes_msgs.msg.Shape()
      if self.constraint_region_orientation is None:
        self.constraint_region_orientation = geometry_msgs.msg.Quaternion()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.link_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.link_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 49
      (self.target_point_offset.x, self.target_point_offset.y, self.target_point_offset.z, self.position.x, self.position.y, self.position.z, self.constraint_region_shape.type,) = struct.unpack('<6db',str[start:end])
      #deserialize self.constraint_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.constraint_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      #deserialize self.constraint_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraint_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.constraint_region_shape.vertices.append(val1)
      start = end
      end += 40
      (self.constraint_region_orientation.x, self.constraint_region_orientation.y, self.constraint_region_orientation.z, self.constraint_region_orientation.w, self.weight,) = struct.unpack('<5d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

