# autogenerated by genmsg_py from WorkspaceParameters.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg
import geometric_shapes_msgs.msg

class WorkspaceParameters(roslib.message.Message):
  _md5sum = "1487490edff0df276863abf2cf221de5"
  _type = "motion_planning_msgs/WorkspaceParameters"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This message contains a set of parameters useful in
# setting up the workspace for planning
geometric_shapes_msgs/Shape  workspace_region_shape
geometry_msgs/PoseStamped    workspace_region_pose


================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['workspace_region_shape','workspace_region_pose']
  _slot_types = ['geometric_shapes_msgs/Shape','geometry_msgs/PoseStamped']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   workspace_region_shape,workspace_region_pose
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(WorkspaceParameters, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.workspace_region_shape is None:
        self.workspace_region_shape = geometric_shapes_msgs.msg.Shape()
      if self.workspace_region_pose is None:
        self.workspace_region_pose = geometry_msgs.msg.PoseStamped()
    else:
      self.workspace_region_shape = geometric_shapes_msgs.msg.Shape()
      self.workspace_region_pose = geometry_msgs.msg.PoseStamped()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<b', self.workspace_region_shape.type))
      #serialize self.workspace_region_shape.dimensions
      length = len(self.workspace_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.workspace_region_shape.dimensions))
      #serialize self.workspace_region_shape.triangles
      length = len(self.workspace_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.workspace_region_shape.triangles))
      #serialize self.workspace_region_shape.vertices
      length = len(self.workspace_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.workspace_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.workspace_region_pose.header.seq, self.workspace_region_pose.header.stamp.secs, self.workspace_region_pose.header.stamp.nsecs))
      length = len(self.workspace_region_pose.header.frame_id)
      #serialize self.workspace_region_pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.workspace_region_pose.header.frame_id))
      buff.write(struct.pack('<7d', self.workspace_region_pose.pose.position.x, self.workspace_region_pose.pose.position.y, self.workspace_region_pose.pose.position.z, self.workspace_region_pose.pose.orientation.x, self.workspace_region_pose.pose.orientation.y, self.workspace_region_pose.pose.orientation.z, self.workspace_region_pose.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.workspace_region_shape is None:
        self.workspace_region_shape = geometric_shapes_msgs.msg.Shape()
      if self.workspace_region_pose is None:
        self.workspace_region_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 1
      (self.workspace_region_shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.workspace_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_region_shape.dimensions = struct.unpack(pattern, str[start:end])
      #deserialize self.workspace_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_region_shape.triangles = struct.unpack(pattern, str[start:end])
      #deserialize self.workspace_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.workspace_region_shape.vertices.append(val1)
      start = end
      end += 12
      (self.workspace_region_pose.header.seq, self.workspace_region_pose.header.stamp.secs, self.workspace_region_pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.workspace_region_pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.workspace_region_pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.workspace_region_pose.pose.position.x, self.workspace_region_pose.pose.position.y, self.workspace_region_pose.pose.position.z, self.workspace_region_pose.pose.orientation.x, self.workspace_region_pose.pose.orientation.y, self.workspace_region_pose.pose.orientation.z, self.workspace_region_pose.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<b', self.workspace_region_shape.type))
      #serialize self.workspace_region_shape.dimensions
      length = len(self.workspace_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.workspace_region_shape.dimensions.tostring())
      #serialize self.workspace_region_shape.triangles
      length = len(self.workspace_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(self.workspace_region_shape.triangles.tostring())
      #serialize self.workspace_region_shape.vertices
      length = len(self.workspace_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.workspace_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.workspace_region_pose.header.seq, self.workspace_region_pose.header.stamp.secs, self.workspace_region_pose.header.stamp.nsecs))
      length = len(self.workspace_region_pose.header.frame_id)
      #serialize self.workspace_region_pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.workspace_region_pose.header.frame_id))
      buff.write(struct.pack('<7d', self.workspace_region_pose.pose.position.x, self.workspace_region_pose.pose.position.y, self.workspace_region_pose.pose.position.z, self.workspace_region_pose.pose.orientation.x, self.workspace_region_pose.pose.orientation.y, self.workspace_region_pose.pose.orientation.z, self.workspace_region_pose.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.workspace_region_shape is None:
        self.workspace_region_shape = geometric_shapes_msgs.msg.Shape()
      if self.workspace_region_pose is None:
        self.workspace_region_pose = geometry_msgs.msg.PoseStamped()
      end = 0
      start = end
      end += 1
      (self.workspace_region_shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.workspace_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.workspace_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      #deserialize self.workspace_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.workspace_region_shape.vertices.append(val1)
      start = end
      end += 12
      (self.workspace_region_pose.header.seq, self.workspace_region_pose.header.stamp.secs, self.workspace_region_pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.workspace_region_pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.workspace_region_pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.workspace_region_pose.pose.position.x, self.workspace_region_pose.pose.position.y, self.workspace_region_pose.pose.position.z, self.workspace_region_pose.pose.orientation.x, self.workspace_region_pose.pose.orientation.y, self.workspace_region_pose.pose.orientation.z, self.workspace_region_pose.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

